package org.expeditee.agents;

import java.util.Collection;

import org.expeditee.gui.Frame;
import org.expeditee.gui.FrameGraphics;
import org.expeditee.gui.FrameIO;

public class SearchFramesetFast extends SearchAgent {
	private long _firstFrame = 1;

	private long _maxFrame = Integer.MAX_VALUE;

	public SearchFramesetFast(String searchText) {
		super(searchText);
	}
	
	public SearchFramesetFast(String searchText, long firstFrame, long maxFrame) {
		this(searchText);
		_firstFrame = firstFrame;
		_maxFrame = maxFrame;
	}

	@Override
	protected Frame process(Frame frame) {
		if(frame == null) {
			frame = FrameIO.LoadFrame(_startName + '0');
		}
		String path = frame.getPath();
		
		int count = FrameIO.getLastNumber(_startName);
		for (long i = _firstFrame;i <= _maxFrame && i <= count; i++) {
			if (_stop) {
				break;
			}
			String frameName = _startName + i;
			overwriteMessage("Searching " + frameName);
			Collection<String> found = FrameIO.searchFrame(frameName, _pattern, path);
			int size = found == null? 0 :found.size();
			// If the frame exists
			if(found != null)
				_frameCount++;
			if(size > 0){
				String repeats = size > 1? ("("+ size+ ")") : "";
				_results.addText(frameName + repeats, null, frameName, null, false);
				FrameGraphics.requestRefresh(true);
			}
		}
		_results.save();

		String resultFrameName = _results.getName();
		if (_clicked != null)
			_clicked.setLink(resultFrameName);

		return _results.getFirstFrame();
	}
}
